#[derive(
    Debug,
    Clone,
    conjure_object::serde::Serialize,
    conjure_object::serde::Deserialize,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash
)]
#[serde(crate = "conjure_object::serde")]
#[conjure_object::private::staged_builder::staged_builder]
#[builder(crate = conjure_object::private::staged_builder, update, inline)]
pub struct CannotPerformCheckAlertAction {
    #[builder(
        default,
        set(
            item(
                type = super::super::super::super::super::objects::scout::rids::api::CheckAlertRid
            )
        )
    )]
    #[serde(
        rename = "checkAlertRids",
        skip_serializing_if = "std::collections::BTreeSet::is_empty",
        default
    )]
    check_alert_rids: std::collections::BTreeSet<
        super::super::super::super::super::objects::scout::rids::api::CheckAlertRid,
    >,
    #[builder(default, into)]
    #[serde(rename = "reason", skip_serializing_if = "Option::is_none", default)]
    reason: Option<String>,
}
impl CannotPerformCheckAlertAction {
    /// Constructs a new instance of the type.
    #[inline]
    pub fn new() -> Self {
        Self::builder().build()
    }
    #[inline]
    pub fn check_alert_rids(
        &self,
    ) -> &std::collections::BTreeSet<
        super::super::super::super::super::objects::scout::rids::api::CheckAlertRid,
    > {
        &self.check_alert_rids
    }
    #[inline]
    pub fn reason(&self) -> Option<&str> {
        self.reason.as_ref().map(|o| &**o)
    }
}
impl conjure_error::ErrorType for CannotPerformCheckAlertAction {
    #[inline]
    fn code() -> conjure_error::ErrorCode {
        conjure_error::ErrorCode::InvalidArgument
    }
    #[inline]
    fn name() -> &'static str {
        "DataReview:CannotPerformCheckAlertAction"
    }
    #[inline]
    fn safe_args() -> &'static [&'static str] {
        &["checkAlertRids", "reason"]
    }
}
